Index: waflib/Tools/icpc.py
===================================================================
--- waflib/Tools/icpc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/icpc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -10,14 +10,7 @@
 	if sys.platform=='cygwin':
 		conf.fatal('The Intel compiler does not work on Cygwin')
-	v=conf.env
-	cxx=None
-	if v['CXX']:cxx=v['CXX']
-	elif'CXX'in conf.environ:cxx=conf.environ['CXX']
-	if not cxx:cxx=conf.find_program('icpc',var='CXX')
-	if not cxx:conf.fatal('Intel C++ Compiler (icpc) was not found')
-	cxx=conf.cmd_to_list(cxx)
+	cxx=conf.find_program('icpc',var='CXX')
 	conf.get_cc_version(cxx,icc=True)
-	v['CXX']=cxx
-	v['CXX_NAME']='icc'
+	conf.env.CXX_NAME='icc'
 def configure(conf):
 	conf.find_icpc()
Index: waflib/Tools/ifort.py
===================================================================
--- waflib/Tools/ifort.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/ifort.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -10,5 +10,4 @@
 def find_ifort(conf):
 	fc=conf.find_program('ifort',var='FC')
-	fc=conf.cmd_to_list(fc)
 	conf.get_ifort_version(fc)
 	conf.env.FC_NAME='IFORT'
@@ -30,6 +29,9 @@
 @conf
 def get_ifort_version(conf,fc):
-	version_re=re.compile(r"ifort\s*\(IFORT\)\s*(?P<major>\d*)\.(?P<minor>\d*)",re.I).search
-	cmd=fc+['--version']
+	version_re=re.compile(r"Intel[\sa-zA-Z()0-9,-]*Version\s*(?P<major>\d*)\.(?P<minor>\d*)",re.I).search
+	if Utils.is_win32:
+		cmd=fc
+	else:
+		cmd=fc+['-logo']
 	out,err=fc_config.getoutput(conf,cmd,stdin=False)
 	if out:
Index: waflib/Tools/intltool.py
===================================================================
--- waflib/Tools/intltool.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/intltool.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -4,8 +4,17 @@
 
 import os,re
-from waflib import Configure,TaskGen,Task,Utils,Runner,Options,Build,Logs
+from waflib import Configure,Context,TaskGen,Task,Utils,Runner,Options,Build,Logs
 import waflib.Tools.ccroot
-from waflib.TaskGen import feature,before_method
+from waflib.TaskGen import feature,before_method,taskgen_method
 from waflib.Logs import error
+from waflib.Configure import conf
+_style_flags={'ba':'-b','desktop':'-d','keys':'-k','quoted':'--quoted-style','quotedxml':'--quotedxml-style','rfc822deb':'-r','schemas':'-s','xml':'-x',}
+@taskgen_method
+def ensure_localedir(self):
+	if not self.env.LOCALEDIR:
+		if self.env.DATAROOTDIR:
+			self.env.LOCALEDIR=os.path.join(self.env.DATAROOTDIR,'locale')
+		else:
+			self.env.LOCALEDIR=os.path.join(self.env.PREFIX,'share','locale')
 @before_method('process_source')
 @feature('intltool_in')
@@ -13,19 +22,27 @@
 	try:self.meths.remove('process_source')
 	except ValueError:pass
-	if not self.env.LOCALEDIR:
-		self.env.LOCALEDIR=self.env.PREFIX+'/share/locale'
+	self.ensure_localedir()
+	podir=getattr(self,'podir','.')
+	podirnode=self.path.find_dir(podir)
+	if not podirnode:
+		error("could not find the podir %r"%podir)
+		return
+	cache=getattr(self,'intlcache','.intlcache')
+	self.env.INTLCACHE=[os.path.join(str(self.path.get_bld()),podir,cache)]
+	self.env.INTLPODIR=podirnode.bldpath()
+	self.env.append_value('INTLFLAGS',getattr(self,'flags',self.env.INTLFLAGS_DEFAULT))
+	if'-c'in self.env.INTLFLAGS:
+		self.bld.fatal('Redundant -c flag in intltool task %r'%self)
+	style=getattr(self,'style',None)
+	if style:
+		try:
+			style_flag=_style_flags[style]
+		except KeyError:
+			self.bld.fatal('intltool_in style "%s" is not valid'%style)
+		self.env.append_unique('INTLFLAGS',[style_flag])
 	for i in self.to_list(self.source):
 		node=self.path.find_resource(i)
-		podir=getattr(self,'podir','po')
-		podirnode=self.path.find_dir(podir)
-		if not podirnode:
-			error("could not find the podir %r"%podir)
-			continue
-		cache=getattr(self,'intlcache','.intlcache')
-		self.env['INTLCACHE']=os.path.join(self.path.bldpath(),podir,cache)
-		self.env['INTLPODIR']=podirnode.bldpath()
-		self.env['INTLFLAGS']=getattr(self,'flags',['-q','-u','-c'])
 		task=self.create_task('intltool',node,node.change_ext(''))
-		inst=getattr(self,'install_path','${LOCALEDIR}')
+		inst=getattr(self,'install_path',None)
 		if inst:
 			self.bld.install_files(inst,task.outputs)
@@ -34,8 +51,7 @@
 	try:self.meths.remove('process_source')
 	except ValueError:pass
-	if not self.env.LOCALEDIR:
-		self.env.LOCALEDIR=self.env.PREFIX+'/share/locale'
-	appname=getattr(self,'appname','set_your_app_name')
-	podir=getattr(self,'podir','')
+	self.ensure_localedir()
+	appname=getattr(self,'appname',getattr(Context.g_module,Context.APPNAME,'set_your_app_name'))
+	podir=getattr(self,'podir','.')
 	inst=getattr(self,'install_path','${LOCALEDIR}')
 	linguas=self.path.find_node(os.path.join(podir,'LINGUAS'))
@@ -63,15 +79,19 @@
 	color='BLUE'
 class intltool(Task.Task):
-	run_str='${INTLTOOL} ${INTLFLAGS} ${INTLCACHE} ${INTLPODIR} ${SRC} ${TGT}'
+	run_str='${INTLTOOL} ${INTLFLAGS} ${INTLCACHE_ST:INTLCACHE} ${INTLPODIR} ${SRC} ${TGT}'
 	color='BLUE'
+@conf
+def find_msgfmt(conf):
+	conf.find_program('msgfmt',var='MSGFMT')
+@conf
+def find_intltool_merge(conf):
+	if not conf.env.PERL:
+		conf.find_program('perl',var='PERL')
+	conf.env.INTLCACHE_ST='--cache=%s'
+	conf.env.INTLFLAGS_DEFAULT=['-q','-u']
+	conf.find_program('intltool-merge',interpreter='PERL',var='INTLTOOL')
 def configure(conf):
-	conf.find_program('msgfmt',var='MSGFMT')
-	conf.find_perl_program('intltool-merge',var='INTLTOOL')
-	prefix=conf.env.PREFIX
-	datadir=conf.env.DATADIR
-	if not datadir:
-		datadir=os.path.join(prefix,'share')
-	conf.define('LOCALEDIR',os.path.join(datadir,'locale').replace('\\','\\\\'))
-	conf.define('DATADIR',datadir.replace('\\','\\\\'))
+	conf.find_msgfmt()
+	conf.find_intltool_merge()
 	if conf.env.CC or conf.env.CXX:
 		conf.check(header_name='locale.h')
Index: waflib/Tools/irixcc.py
===================================================================
--- waflib/Tools/irixcc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/irixcc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -15,5 +15,4 @@
 	if not cc:cc=conf.find_program('cc',var='CC')
 	if not cc:conf.fatal('irixcc was not found')
-	cc=conf.cmd_to_list(cc)
 	try:
 		conf.cmd_and_log(cc+['-version'])
Index: waflib/Tools/javaw.py
===================================================================
--- waflib/Tools/javaw.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/javaw.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -158,5 +158,4 @@
 class javac(Task.Task):
 	color='BLUE'
-	nocache=True
 	vars=['CLASSPATH','JAVACFLAGS','JAVAC','OUTDIR']
 	def runnable_status(self):
@@ -254,5 +253,4 @@
 	for x in'javac java jar javadoc'.split():
 		self.find_program(x,var=x.upper(),path_list=java_path)
-		self.env[x.upper()]=self.cmd_to_list(self.env[x.upper()])
 	if'CLASSPATH'in self.environ:
 		v['CLASSPATH']=self.environ['CLASSPATH']
Index: waflib/Tools/kde4.py
===================================================================
--- waflib/Tools/kde4.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/kde4.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -20,5 +20,5 @@
 def configure(self):
 	kdeconfig=self.find_program('kde4-config')
-	prefix=self.cmd_and_log('%s --prefix'%kdeconfig).strip()
+	prefix=self.cmd_and_log(kdeconfig+['--prefix']).strip()
 	fname='%s/share/apps/cmake/modules/KDELibsDependencies.cmake'%prefix
 	try:os.stat(fname)
@@ -29,5 +29,5 @@
 	try:
 		txt=Utils.readf(fname)
-	except(OSError,IOError):
+	except EnvironmentError:
 		self.fatal('could not read %s'%fname)
 	txt=txt.replace('\\\n','\n')
Index: waflib/Tools/ldc2.py
===================================================================
--- waflib/Tools/ldc2.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/ldc2.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -9,5 +9,5 @@
 def find_ldc2(conf):
 	conf.find_program(['ldc2'],var='D')
-	out=conf.cmd_and_log([conf.env.D,'-version'])
+	out=conf.cmd_and_log(conf.env.D+['-version'])
 	if out.find("based on DMD v2.")==-1:
 		conf.fatal("detected compiler is not ldc2")
Index: waflib/Tools/msvc.py
===================================================================
--- waflib/Tools/msvc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/msvc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -60,5 +60,9 @@
 def get_msvc_version(conf,compiler,version,target,vcvars):
 	debug('msvc: get_msvc_version: %r %r %r',compiler,version,target)
-	batfile=conf.bldnode.make_node('waf-print-msvc.bat')
+	try:
+		conf.msvc_cnt+=1
+	except AttributeError:
+		conf.msvc_cnt=1
+	batfile=conf.bldnode.make_node('waf-print-msvc-%d.bat'%conf.msvc_cnt)
 	batfile.write("""@echo off
 set INCLUDE=
@@ -69,5 +73,5 @@
 echo LIB=%%LIB%%;%%LIBPATH%%
 """%(vcvars,target))
-	sout=conf.cmd_and_log(['cmd','/E:on','/V:on','/C',batfile.abspath()])
+	sout=conf.cmd_and_log(['cmd.exe','/E:on','/V:on','/C',batfile.abspath()])
 	lines=sout.splitlines()
 	if not lines[0]:
@@ -88,5 +92,4 @@
 	compiler_name,linker_name,lib_name=_get_prog_names(conf,compiler)
 	cxx=conf.find_program(compiler_name,path_list=MSVC_PATH)
-	cxx=conf.cmd_to_list(cxx)
 	if'CL'in env:
 		del(env['CL'])
@@ -176,5 +179,5 @@
 	version_pattern=re.compile('^(\d\d?\.\d\d?)(Exp)?$')
 	detected_versions=[]
-	for vcver,vcvar in[('VCExpress','Exp'),('VisualStudio','')]:
+	for vcver,vcvar in(('VCExpress','Exp'),('VisualStudio','')):
 		try:
 			prefix='SOFTWARE\\Wow6432node\\Microsoft\\'+vcver
@@ -373,5 +376,5 @@
 					patch_url='http://software.intel.com/en-us/forums/topic/328487'
 					compilervars_arch=os.path.join(path,'bin','compilervars_arch.bat')
-					for vscomntool in['VS110COMNTOOLS','VS100COMNTOOLS']:
+					for vscomntool in('VS110COMNTOOLS','VS100COMNTOOLS'):
 						if vscomntool in os.environ:
 							vs_express_path=os.environ[vscomntool]+r'..\IDE\VSWinExpress.exe'
@@ -529,5 +532,4 @@
 	elif'CXX'in conf.environ:cxx=conf.environ['CXX']
 	cxx=conf.find_program(compiler_name,var='CXX',path_list=path)
-	cxx=conf.cmd_to_list(cxx)
 	env=dict(conf.environ)
 	if path:env.update(PATH=';'.join(path))
@@ -619,8 +621,6 @@
 				pdbnode=self.link_task.outputs[0].change_ext('.pdb')
 				self.link_task.outputs.append(pdbnode)
-				try:
-					self.install_task.source.append(pdbnode)
-				except AttributeError:
-					pass
+				if getattr(self,'install_task',None):
+					self.pdb_install_task=self.bld.install_files(self.install_task.dest,pdbnode,env=self.env)
 				break
 @feature('cprogram','cshlib','cxxprogram','cxxshlib')
@@ -652,11 +652,9 @@
 		mode='2'
 	debug('msvc: embedding manifest in mode %r'%mode)
-	lst=[]
-	lst.append(env['MT'])
+	lst=[]+mtool
 	lst.extend(Utils.to_list(env['MTFLAGS']))
 	lst.extend(['-manifest',manifest])
 	lst.append('-outputresource:%s;%s'%(outfile,mode))
-	lst=[lst]
-	return self.exec_command(*lst)
+	return self.exec_command(lst)
 def quote_response_command(self,flag):
 	if flag.find(' ')>-1:
@@ -726,4 +724,6 @@
 	derived_class.exec_command_msvc=exec_command_msvc
 	derived_class.exec_mf=exec_mf
+	if hasattr(cls,'hcode'):
+		derived_class.hcode=cls.hcode
 	return derived_class
 for k in'c cxx cprogram cxxprogram cshlib cxxshlib cstlib cxxstlib'.split():
Index: waflib/Tools/perl.py
===================================================================
--- waflib/Tools/perl.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/perl.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -37,5 +37,5 @@
 		return False
 	self.env['PERL']=perl
-	version=self.cmd_and_log([perl,"-e",'printf \"%vd\", $^V'])
+	version=self.cmd_and_log(self.env.PERL+["-e",'printf \"%vd\", $^V'])
 	if not version:
 		res=False
@@ -49,5 +49,5 @@
 @conf
 def check_perl_module(self,module):
-	cmd=[self.env['PERL'],'-e','use %s'%module]
+	cmd=self.env.PERL+['-e','use %s'%module]
 	self.start_msg('perl module %s'%module)
 	try:
@@ -64,16 +64,20 @@
 	if not perl:
 		self.fatal('find perl first')
-	def read_out(cmd):
-		return Utils.to_list(self.cmd_and_log(perl+cmd))
-	env['LINKFLAGS_PERLEXT']=read_out(" -MConfig -e'print $Config{lddlflags}'")
-	env['INCLUDES_PERLEXT']=read_out(" -MConfig -e'print \"$Config{archlib}/CORE\"'")
-	env['CFLAGS_PERLEXT']=read_out(" -MConfig -e'print \"$Config{ccflags} $Config{cccdlflags}\"'")
-	env['XSUBPP']=read_out(" -MConfig -e'print \"$Config{privlib}/ExtUtils/xsubpp$Config{exe_ext}\"'")
-	env['EXTUTILS_TYPEMAP']=read_out(" -MConfig -e'print \"$Config{privlib}/ExtUtils/typemap\"'")
+	def cmd_perl_config(s):
+		return perl+['-MConfig','-e','print \"%s\"'%s]
+	def cfg_str(cfg):
+		return self.cmd_and_log(cmd_perl_config(cfg))
+	def cfg_lst(cfg):
+		return Utils.to_list(cfg_str(cfg))
+	env['LINKFLAGS_PERLEXT']=cfg_lst('$Config{lddlflags}')
+	env['INCLUDES_PERLEXT']=cfg_lst('$Config{archlib}/CORE')
+	env['CFLAGS_PERLEXT']=cfg_lst('$Config{ccflags} $Config{cccdlflags}')
+	env['XSUBPP']=cfg_lst('$Config{privlib}/ExtUtils/xsubpp$Config{exe_ext}')
+	env['EXTUTILS_TYPEMAP']=cfg_lst('$Config{privlib}/ExtUtils/typemap')
 	if not getattr(Options.options,'perlarchdir',None):
-		env['ARCHDIR_PERL']=self.cmd_and_log(perl+" -MConfig -e'print $Config{sitearch}'")
+		env['ARCHDIR_PERL']=cfg_str('$Config{sitearch}')
 	else:
 		env['ARCHDIR_PERL']=getattr(Options.options,'perlarchdir')
-	env['perlext_PATTERN']='%s.'+self.cmd_and_log(perl+" -MConfig -e'print $Config{dlext}'")
+	env['perlext_PATTERN']='%s.'+cfg_str('$Config{dlext}')
 def options(opt):
 	opt.add_option('--with-perl-binary',type='string',dest='perlbinary',help='Specify alternate perl binary',default=None)
Index: waflib/Tools/python.py
===================================================================
--- waflib/Tools/python.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/python.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -4,5 +4,5 @@
 
 import os,sys
-from waflib import Utils,Options,Errors,Logs
+from waflib import Utils,Options,Errors,Logs,Task,Node
 from waflib.TaskGen import extension,before_method,after_method,feature
 from waflib.Configure import conf
@@ -27,62 +27,64 @@
 INST='''
 import sys, py_compile
-py_compile.compile(sys.argv[1], sys.argv[2], sys.argv[3])
+py_compile.compile(sys.argv[1], sys.argv[2], sys.argv[3], True)
 '''
 DISTUTILS_IMP=['from distutils.sysconfig import get_config_var, get_python_lib']
+@before_method('process_source')
+@feature('py')
+def feature_py(self):
+	self.install_path=getattr(self,'install_path','${PYTHONDIR}')
+	install_from=getattr(self,'install_from',None)
+	if install_from and not isinstance(install_from,Node.Node):
+		install_from=self.path.find_dir(install_from)
+	self.install_from=install_from
+	ver=self.env.PYTHON_VERSION
+	if not ver:
+		self.bld.fatal('Installing python files requires PYTHON_VERSION, try conf.check_python_version')
+	if int(ver.replace('.',''))>31:
+		self.install_32=True
 @extension('.py')
 def process_py(self,node):
-	try:
-		if not self.bld.is_install:
-			return
-	except AttributeError:
-		return
-	try:
-		if not self.install_path:
-			return
-	except AttributeError:
-		self.install_path='${PYTHONDIR}'
-	def inst_py(ctx):
-		install_from=getattr(self,'install_from',None)
-		if install_from:
-			install_from=self.path.find_dir(install_from)
-		install_pyfile(self,node,install_from)
-	self.bld.add_post_fun(inst_py)
-def install_pyfile(self,node,install_from=None):
-	from_node=install_from or node.parent
-	tsk=self.bld.install_as(self.install_path+'/'+node.path_from(from_node),node,postpone=False)
-	path=tsk.get_install_path()
-	if self.bld.is_install<0:
-		Logs.info("+ removing byte compiled python files")
-		for x in'co':
-			try:
-				os.remove(path+x)
-			except OSError:
-				pass
-	if self.bld.is_install>0:
-		try:
-			st1=os.stat(path)
-		except OSError:
-			Logs.error('The python file is missing, this should not happen')
-		for x in['c','o']:
-			do_inst=self.env['PY'+x.upper()]
-			try:
-				st2=os.stat(path+x)
-			except OSError:
-				pass
-			else:
-				if st1.st_mtime<=st2.st_mtime:
-					do_inst=False
-			if do_inst:
-				lst=(x=='o')and[self.env['PYFLAGS_OPT']]or[]
-				(a,b,c)=(path,path+x,tsk.get_install_path(destdir=False)+x)
-				argv=self.env['PYTHON']+lst+['-c',INST,a,b,c]
-				Logs.info('+ byte compiling %r'%(path+x))
-				env=self.env.env or None
-				ret=Utils.subprocess.Popen(argv,env=env).wait()
-				if ret:
-					raise Errors.WafError('py%s compilation failed %r'%(x,path))
-@feature('py')
-def feature_py(self):
-	pass
+	assert(node.get_bld_sig())
+	assert(getattr(self,'install_path')),'add features="py"'
+	if self.install_path:
+		if self.install_from:
+			self.bld.install_files(self.install_path,[node],cwd=self.install_from,relative_trick=True)
+		else:
+			self.bld.install_files(self.install_path,[node],relative_trick=True)
+	lst=[]
+	if self.env.PYC:
+		lst.append('pyc')
+	if self.env.PYO:
+		lst.append('pyo')
+	if self.install_path:
+		if self.install_from:
+			pyd=Utils.subst_vars("%s/%s"%(self.install_path,node.path_from(self.install_from)),self.env)
+		else:
+			pyd=Utils.subst_vars("%s/%s"%(self.install_path,node.path_from(self.path)),self.env)
+	else:
+		pyd=node.abspath()
+	for ext in lst:
+		if self.env.PYTAG:
+			name=node.name[:-3]
+			pyobj=node.parent.get_bld().make_node('__pycache__').make_node("%s.%s.%s"%(name,self.env.PYTAG,ext))
+			pyobj.parent.mkdir()
+		else:
+			pyobj=node.change_ext(".%s"%ext)
+		tsk=self.create_task(ext,node,pyobj)
+		tsk.pyd=pyd
+		if self.install_path:
+			self.bld.install_files(os.path.dirname(pyd),pyobj,cwd=node.parent.get_bld(),relative_trick=True)
+class pyc(Task.Task):
+	color='PINK'
+	def run(self):
+		cmd=[Utils.subst_vars('${PYTHON}',self.env),'-c',INST,self.inputs[0].abspath(),self.outputs[0].abspath(),self.pyd]
+		ret=self.generator.bld.exec_command(cmd)
+		return ret
+class pyo(Task.Task):
+	color='PINK'
+	def run(self):
+		cmd=[Utils.subst_vars('${PYTHON}',self.env),Utils.subst_vars('${PYFLAGS_OPT}',self.env),'-c',INST,self.inputs[0].abspath(),self.outputs[0].abspath(),self.pyd]
+		ret=self.generator.bld.exec_command(cmd)
+		return ret
 @feature('pyext')
 @before_method('propagate_uselib_vars','apply_link')
@@ -132,5 +134,5 @@
 	self.to_log(out)
 	return_values=[]
-	for s in out.split('\n'):
+	for s in out.splitlines():
 		s=s.strip()
 		if not s:
@@ -145,14 +147,44 @@
 	return return_values
 @conf
-def check_python_headers(conf):
+def python_cross_compile(self,features='pyembed pyext'):
+	features=Utils.to_list(features)
+	if not('PYTHON_LDFLAGS'in self.environ or'PYTHON_PYEXT_LDFLAGS'in self.environ or'PYTHON_PYEMBED_LDFLAGS'in self.environ):
+		return False
+	for x in'PYTHON_VERSION PYTAG pyext_PATTERN'.split():
+		if not x in self.environ:
+			self.fatal('Please set %s in the os environment'%x)
+		else:
+			self.env[x]=self.environ[x]
+	xx=self.env.CXX_NAME and'cxx'or'c'
+	if'pyext'in features:
+		flags=self.environ.get('PYTHON_PYEXT_LDFLAGS',self.environ.get('PYTHON_LDFLAGS',None))
+		if flags is None:
+			self.fatal('No flags provided through PYTHON_PYEXT_LDFLAGS as required')
+		else:
+			self.parse_flags(flags,'PYEXT')
+		self.check(header_name='Python.h',define_name='HAVE_PYEXT',msg='Testing pyext configuration',features='%s %sshlib pyext'%(xx,xx),fragment=FRAG,errmsg='Could not build python extensions')
+	if'pyembed'in features:
+		flags=self.environ.get('PYTHON_PYEMBED_LDFLAGS',self.environ.get('PYTHON_LDFLAGS',None))
+		if flags is None:
+			self.fatal('No flags provided through PYTHON_PYEMBED_LDFLAGS as required')
+		else:
+			self.parse_flags(flags,'PYEMBED')
+		self.check(header_name='Python.h',define_name='HAVE_PYEMBED',msg='Testing pyembed configuration',fragment=FRAG,errmsg='Could not build a python embedded interpreter',features='%s %sprogram pyembed'%(xx,xx))
+	return True
+@conf
+def check_python_headers(conf,features='pyembed pyext'):
+	features=Utils.to_list(features)
+	assert('pyembed'in features)or('pyext'in features),"check_python_headers features must include 'pyembed' and/or 'pyext'"
 	env=conf.env
 	if not env['CC_NAME']and not env['CXX_NAME']:
 		conf.fatal('load a compiler first (gcc, g++, ..)')
+	if conf.python_cross_compile(features):
+		return
 	if not env['PYTHON_VERSION']:
 		conf.check_python_version()
-	pybin=conf.env.PYTHON
+	pybin=env.PYTHON
 	if not pybin:
 		conf.fatal('Could not find the python executable')
-	v='prefix SO LDFLAGS LIBDIR LIBPL INCLUDEPY Py_ENABLE_SHARED MACOSX_DEPLOYMENT_TARGET LDSHARED CFLAGS'.split()
+	v='prefix SO LDFLAGS LIBDIR LIBPL INCLUDEPY Py_ENABLE_SHARED MACOSX_DEPLOYMENT_TARGET LDSHARED CFLAGS LDVERSION'.split()
 	try:
 		lst=conf.get_python_variables(["get_config_var('%s') or ''"%x for x in v])
@@ -160,10 +192,27 @@
 		conf.fatal("Python development headers not found (-v for details).")
 	vals=['%s = %r'%(x,y)for(x,y)in zip(v,lst)]
-	conf.to_log("Configuration returned from %r:\n%r\n"%(pybin,'\n'.join(vals)))
+	conf.to_log("Configuration returned from %r:\n%s\n"%(pybin,'\n'.join(vals)))
 	dct=dict(zip(v,lst))
 	x='MACOSX_DEPLOYMENT_TARGET'
 	if dct[x]:
-		conf.env[x]=conf.environ[x]=dct[x]
+		env[x]=conf.environ[x]=dct[x]
 	env['pyext_PATTERN']='%s'+dct['SO']
+	num='.'.join(env['PYTHON_VERSION'].split('.')[:2])
+	conf.find_program([''.join(pybin)+'-config','python%s-config'%num,'python-config-%s'%num,'python%sm-config'%num],var='PYTHON_CONFIG',msg="python-config",mandatory=False)
+	if env.PYTHON_CONFIG:
+		all_flags=[['--cflags','--libs','--ldflags']]
+		if sys.hexversion<0x2070000:
+			all_flags=[[k]for k in all_flags[0]]
+		xx=env.CXX_NAME and'cxx'or'c'
+		if'pyembed'in features:
+			for flags in all_flags:
+				conf.check_cfg(msg='Asking python-config for pyembed %r flags'%' '.join(flags),path=env.PYTHON_CONFIG,package='',uselib_store='PYEMBED',args=flags)
+			conf.check(header_name='Python.h',define_name='HAVE_PYEMBED',msg='Getting pyembed flags from python-config',fragment=FRAG,errmsg='Could not build a python embedded interpreter',features='%s %sprogram pyembed'%(xx,xx))
+		if'pyext'in features:
+			for flags in all_flags:
+				conf.check_cfg(msg='Asking python-config for pyext %r flags'%' '.join(flags),path=env.PYTHON_CONFIG,package='',uselib_store='PYEXT',args=flags)
+			conf.check(header_name='Python.h',define_name='HAVE_PYEXT',msg='Getting pyext flags from python-config',features='%s %sshlib pyext'%(xx,xx),fragment=FRAG,errmsg='Could not build python extensions')
+		conf.define('HAVE_PYTHON_H',1)
+		return
 	all_flags=dct['LDFLAGS']+' '+dct['CFLAGS']
 	conf.parse_flags(all_flags,'PYEMBED')
@@ -171,5 +220,7 @@
 	conf.parse_flags(all_flags,'PYEXT')
 	result=None
-	for name in('python'+env['PYTHON_VERSION'],'python'+env['PYTHON_VERSION']+'m','python'+env['PYTHON_VERSION'].replace('.','')):
+	if not dct["LDVERSION"]:
+		dct["LDVERSION"]=env['PYTHON_VERSION']
+	for name in('python'+dct['LDVERSION'],'python'+env['PYTHON_VERSION']+'m','python'+env['PYTHON_VERSION'].replace('.','')):
 		if not result and env['LIBPATH_PYEMBED']:
 			path=env['LIBPATH_PYEMBED']
@@ -195,23 +246,10 @@
 	else:
 		conf.to_log("\n\n### LIB NOT FOUND\n")
-	if(Utils.is_win32 or sys.platform.startswith('os2')or dct['Py_ENABLE_SHARED']):
+	if Utils.is_win32 or dct['Py_ENABLE_SHARED']:
 		env['LIBPATH_PYEXT']=env['LIBPATH_PYEMBED']
 		env['LIB_PYEXT']=env['LIB_PYEMBED']
-	num='.'.join(env['PYTHON_VERSION'].split('.')[:2])
-	conf.find_program([''.join(pybin)+'-config','python%s-config'%num,'python-config-%s'%num,'python%sm-config'%num],var='PYTHON_CONFIG',mandatory=False)
-	includes=[]
-	if conf.env.PYTHON_CONFIG:
-		for incstr in conf.cmd_and_log([conf.env.PYTHON_CONFIG,'--includes']).strip().split():
-			if(incstr.startswith('-I')or incstr.startswith('/I')):
-				incstr=incstr[2:]
-			if incstr not in includes:
-				includes.append(incstr)
-		conf.to_log("Include path for Python extensions (found via python-config --includes): %r\n"%(includes,))
-		env['INCLUDES_PYEXT']=includes
-		env['INCLUDES_PYEMBED']=includes
-	else:
-		conf.to_log("Include path for Python extensions ""(found via distutils module): %r\n"%(dct['INCLUDEPY'],))
-		env['INCLUDES_PYEXT']=[dct['INCLUDEPY']]
-		env['INCLUDES_PYEMBED']=[dct['INCLUDEPY']]
+	conf.to_log("Include path for Python extensions (found via distutils module): %r\n"%(dct['INCLUDEPY'],))
+	env['INCLUDES_PYEXT']=[dct['INCLUDEPY']]
+	env['INCLUDES_PYEMBED']=[dct['INCLUDEPY']]
 	if env['CC_NAME']=='gcc':
 		env.append_value('CFLAGS_PYEMBED',['-fno-strict-aliasing'])
@@ -227,15 +265,5 @@
 		env.append_value('CXXFLAGS_PYEXT',dist_compiler.compile_options)
 		env.append_value('LINKFLAGS_PYEXT',dist_compiler.ldflags_shared)
-	try:
-		conf.check(header_name='Python.h',define_name='HAVE_PYTHON_H',uselib='PYEMBED',fragment=FRAG,errmsg=':-(')
-	except conf.errors.ConfigurationError:
-		xx=conf.env.CXX_NAME and'cxx'or'c'
-		flags=['--cflags','--libs','--ldflags']
-		for f in flags:
-			conf.check_cfg(msg='Asking python-config for pyembed %s flags'%f,path=conf.env.PYTHON_CONFIG,package='',uselib_store='PYEMBED',args=[f])
-		conf.check(header_name='Python.h',define_name='HAVE_PYTHON_H',msg='Getting pyembed flags from python-config',fragment=FRAG,errmsg='Could not build a python embedded interpreter',features='%s %sprogram pyembed'%(xx,xx))
-		for f in flags:
-			conf.check_cfg(msg='Asking python-config for pyext %s flags'%f,path=conf.env.PYTHON_CONFIG,package='',uselib_store='PYEXT',args=[f])
-		conf.check(header_name='Python.h',define_name='HAVE_PYTHON_H',msg='Getting pyext flags from python-config',features='%s %sshlib pyext'%(xx,xx),fragment=FRAG,errmsg='Could not build python extensions')
+	conf.check(header_name='Python.h',define_name='HAVE_PYTHON_H',uselib='PYEMBED',fragment=FRAG,errmsg='Distutils not installed? Broken python installation? Get python-config now!')
 @conf
 def check_python_version(conf,minver=None):
@@ -253,12 +281,14 @@
 		pyver='.'.join([str(x)for x in pyver_tuple[:2]])
 		conf.env['PYTHON_VERSION']=pyver
-		if'PYTHONDIR'in conf.environ:
+		if'PYTHONDIR'in conf.env:
+			pydir=conf.env['PYTHONDIR']
+		elif'PYTHONDIR'in conf.environ:
 			pydir=conf.environ['PYTHONDIR']
 		else:
 			if Utils.is_win32:
-				(python_LIBDEST,pydir)=conf.get_python_variables(["get_config_var('LIBDEST') or ''","get_python_lib(standard_lib=0, prefix=%r) or ''"%conf.env['PREFIX']])
+				(python_LIBDEST,pydir)=conf.get_python_variables(["get_config_var('LIBDEST') or ''","get_python_lib(standard_lib=0) or ''"])
 			else:
 				python_LIBDEST=None
-				(pydir,)=conf.get_python_variables(["get_python_lib(standard_lib=0, prefix=%r) or ''"%conf.env['PREFIX']])
+				(pydir,)=conf.get_python_variables(["get_python_lib(standard_lib=0) or ''"])
 			if python_LIBDEST is None:
 				if conf.env['LIBDIR']:
@@ -266,8 +296,10 @@
 				else:
 					python_LIBDEST=os.path.join(conf.env['PREFIX'],"lib","python"+pyver)
-		if'PYTHONARCHDIR'in conf.environ:
+		if'PYTHONARCHDIR'in conf.env:
+			pyarchdir=conf.env['PYTHONARCHDIR']
+		elif'PYTHONARCHDIR'in conf.environ:
 			pyarchdir=conf.environ['PYTHONARCHDIR']
 		else:
-			(pyarchdir,)=conf.get_python_variables(["get_python_lib(plat_specific=1, standard_lib=0, prefix=%r) or ''"%conf.env['PREFIX']])
+			(pyarchdir,)=conf.get_python_variables(["get_python_lib(plat_specific=1, standard_lib=0) or ''"])
 			if not pyarchdir:
 				pyarchdir=pydir
@@ -289,11 +321,11 @@
 version = getattr(current_module, '__version__', None)
 if version is not None:
-    print(str(version))
+	print(str(version))
 else:
-    print('unknown version')
+	print('unknown version')
 '''
 @conf
 def check_python_module(conf,module_name,condition=''):
-	msg='Python module %s'%module_name
+	msg="Checking for python module '%s'"%module_name
 	if condition:
 		msg='%s (%s)'%(msg,condition)
@@ -325,19 +357,24 @@
 			conf.end_msg(ret)
 def configure(conf):
-	try:
-		conf.find_program('python',var='PYTHON')
-	except conf.errors.ConfigurationError:
-		Logs.warn("could not find a python executable, setting to sys.executable '%s'"%sys.executable)
-		conf.env.PYTHON=sys.executable
-	if conf.env.PYTHON!=sys.executable:
-		Logs.warn("python executable %r differs from system %r"%(conf.env.PYTHON,sys.executable))
-	conf.env.PYTHON=conf.cmd_to_list(conf.env.PYTHON)
 	v=conf.env
-	v['PYCMD']='"import sys, py_compile;py_compile.compile(sys.argv[1], sys.argv[2])"'
+	v['PYTHON']=Options.options.python or os.environ.get('PYTHON',sys.executable)
+	if Options.options.pythondir:
+		v['PYTHONDIR']=Options.options.pythondir
+	if Options.options.pythonarchdir:
+		v['PYTHONARCHDIR']=Options.options.pythonarchdir
+	conf.find_program('python',var='PYTHON')
 	v['PYFLAGS']=''
 	v['PYFLAGS_OPT']='-O'
 	v['PYC']=getattr(Options.options,'pyc',1)
 	v['PYO']=getattr(Options.options,'pyo',1)
+	try:
+		v.PYTAG=conf.cmd_and_log(conf.env.PYTHON+['-c',"import imp;print(imp.get_tag())"]).strip()
+	except Errors.WafError:
+		pass
 def options(opt):
-	opt.add_option('--nopyc',action='store_false',default=1,help='Do not install bytecode compiled .pyc files (configuration) [Default:install]',dest='pyc')
-	opt.add_option('--nopyo',action='store_false',default=1,help='Do not install optimised compiled .pyo files (configuration) [Default:install]',dest='pyo')
+	pyopt=opt.add_option_group("Python Options")
+	pyopt.add_option('--nopyc',dest='pyc',action='store_false',default=1,help='Do not install bytecode compiled .pyc files (configuration) [Default:install]')
+	pyopt.add_option('--nopyo',dest='pyo',action='store_false',default=1,help='Do not install optimised compiled .pyo files (configuration) [Default:install]')
+	pyopt.add_option('--python',dest="python",help='python binary to be used [Default: %s]'%sys.executable)
+	pyopt.add_option('--pythondir',dest='pythondir',help='Installation path for python modules (py, platform-independent .py and .pyc files)')
+	pyopt.add_option('--pythonarchdir',dest='pythonarchdir',help='Installation path for python extension (pyext, platform-dependent .so or .dylib files)')
